using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;

namespace CardService
{
	/// <summary>
	/// Summary description for Service1.
	/// </summary>
	public class Service1 : System.Web.Services.WebService
	{
		public Service1()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		public String TrimToDigits( String strCardNumber )
		{
			String strRet = "";
	
			for( int i=0; i<strCardNumber.Length; i++ )
			{
				if( strCardNumber[i] >= '0' && strCardNumber[i] <= '9' )
				{
					strRet += strCardNumber[i];
				}
			}
			return( strRet );
		}

		public int CheckCC( String strCardNumber, String strCardType )
		{
			strCardType.ToUpper();

			bool bLengthValid = true;
			bool bPrefixValid = true;

			switch( strCardType )
			{
				case "M":
					if( strCardNumber.Length != 16 )
					{
						bLengthValid = false;
						break;
					}

					if( !( strCardNumber.IndexOf( "51" ) == 0 ||
						strCardNumber.IndexOf( "52" ) == 0 ||
						strCardNumber.IndexOf( "53" ) == 0 ||
						strCardNumber.IndexOf( "54" ) == 0 ||
						strCardNumber.IndexOf( "55" ) == 0 ) )
					{
						bPrefixValid = false;
						break;
					}

					break;
				case "V":
					if( strCardNumber.Length != 13 && 
						strCardNumber.Length != 16 )
					{
						bLengthValid = false;
						break;
					}

					if( !( strCardNumber.IndexOf( "4" ) == 0 ) )
					{
						bPrefixValid = false;
						break;
					}

					break;
				case "D":
					if( strCardNumber.Length != 16 )
					{
						bLengthValid = false;
						break;
					}

					if( !( strCardNumber.IndexOf( "6011" ) == 0 ) )
					{
						bPrefixValid = false;
						break;
					}

					break;
				case "A":
					if( strCardNumber.Length != 15 )
					{
						bLengthValid = false;
						break;
					}

					if( !( strCardNumber.IndexOf( "34" ) == 0 ||
						strCardNumber.IndexOf( "37" ) == 0  ) )
					{
						bPrefixValid = false;
						break;
					}

					break;
			}

			if( !bLengthValid )
			{
				return( -2 );
			}

			if( !bPrefixValid )
			{
				return( -2 );
			}

			int nQSum = 0;

			for( int x=1; x<=strCardNumber.Length; x++ )
			{
				int nCh = (int) strCardNumber[strCardNumber.Length-x] - '0';
				if( ( x % 2 ) == 0 )
				{
					int nSum = 2 * nCh;
					nQSum = nQSum + ( nSum % 10 );
					if( nSum > 9 )
					{
						nQSum++;
					}
				}
				else
				{
					nQSum = nQSum + nCh;
				}
			}

			if( ( nQSum % 10 ) != 0 )
			{
				return( -4 );
			}

			return( 0 );
		}

		[WebMethod]
		public int CardType( String strCardNumber )
		{

			String strCardNum = TrimToDigits( strCardNumber );
			
			if( CheckCC( strCardNum, "M" ) == 0 )
			{
				return( 1 );
			}

			if( CheckCC( strCardNum, "V" ) == 0 )
			{
				return( 2 );
			}

			if( CheckCC( strCardNum, "A" ) == 0 )
			{
				return( 3 );
			}

			if( CheckCC( strCardNum, "D" ) == 0 )
			{
				return( 4 );
			}

			return( -1 );
		}
	}
}
